


numberOfStates=M_.endo_nbr;
numberOfInnovations=M_.exo_nbr;
 
F_=zeros(numberOfStates,numberOfStates);
B0_=zeros(numberOfStates,numberOfInnovations);
 
% F_(:,oo_.dr.state_var)=oo_.dr.ghx(oo_.dr.inv_order_var,:);
 
 % numberOfDynareStateVars: 'Effective' or 'real' number of state variables (economic states)

numberOfDynareStateVars=size(oo_.dr.state_var,2);   
stateOrderNew=zeros(numberOfDynareStateVars,1);
iter=0;
for i=1:M_.endo_nbr
    stateVarInOrderVar=oo_.dr.order_var(i,1);
    for j=1:size(oo_.dr.state_var,2)
        stateVarInStateVar=oo_.dr.state_var(1,j);
        if stateVarInOrderVar==stateVarInStateVar
            iter=iter+1;
            stateOrderNew(iter,1)=stateVarInOrderVar;
        end;
    end;
end;
F_(:,stateOrderNew)=oo_.dr.ghx(oo_.dr.inv_order_var,:);
B0_=oo_.dr.ghu(oo_.dr.inv_order_var,:);

c_ = oo_.steady_state;

%%

vnames = {'data_RU', 'R_L_Eobs',	'R_Lobs', 'R_Dobs', 'dDebt_Eobs',...
    'dDebtobs', 'PD_Eobs', 'PD_HHobs', 'dDepoobs', 'T_DdiffU', 'data_cdiffU',...	
'data_idiffU',	'data_ydiffU',	'data_xdiffU',	'data_impdiffU', 'data_piiU',...
'data_picU', 'data_pidU','data_pistarU','data_RstarU',	'data_ystardiffU',...
'data_qdiffU', 'data_ldiffU'};

% for i = 1:length(vnames)    
% ivname(i) = iname(vnames{i},M_.endo_names,oo_.dr.order_var);
% end

% oc_ = c_(ivname);
% oF_ = F_(ivname,ivname);
% oB0_ = B0_(ivname,:);
oSigma = M_.Sigma_e;
nori = M_.orig_endo_nbr;

idxtoObs = ismember(M_.endo_names,vnames);

for i = 1:length(vnames)    
CC(i,:) = ismember(M_.endo_names,vnames(i))';
end

CC = [CC zeros(length(vnames),nori)];

DD = 0;
AA = [F_                 eye(nori); ...
      zeros(nori)        eye(nori) ];
  
BB = [ B0_*sqrt(oSigma); zeros(nori,M_.exo_nbr) ];  

%% Conditioning variables 
% CV = {'data_ydiffU'}; % real GDP
CV = {	'data_ydiffU',	'data_xdiffU',	'data_impdiffU',...
'data_pidU','data_pistarU','data_RstarU',	'data_ystardiffU',...
'data_qdiffU'};

% conditioning variables
idxCV = ismember(vnames,CV);

yT = consolidadobase;
yT = [yT;escenarios];
% T = size(yT,1);
% yT(T+1:T+8,~idxCV) = nan; % conditioning set, model in levels
% yT(T+1:T+8,idxCV) = [-0.5; -0.5; -0.5; -0.5; -0.5; -0.5; -0.5; -0.5]; % conditioning set, model in levels




%% Data
X = yT;
[T,N] = size(X);

idxNaN = any(isnan(X),2);
idxNaNcs = cumsum(idxNaN(end:-1:1));
nNaNs = sum(idxNaNcs==(1:T)');

% end part with missing observations
Xub = X(end-nNaNs+1:end,:);
y = Xub;

Xcond = repmat(X,[1 1 1000]);

%% Conditional forecasts


%% State space representation

   
for i = 1:ndraws
        
    ix = ~isnan(y);
    y  =  reshape(y(ix),[nNaNs length(CV)]);
    Cbar  =  CC(ix(1,:),:);  
    
    Mdl = ssm(AA,BB,Cbar,'Mean0',[c_;c_],'Cov0',eye(2*nori)*1e-9);
    Sbar = simsmooth(Mdl,y);
    for t = 1:nNaNs    
        Zbar(t,:) = Sbar(t,:)*CC';
    end
    Xcond(~isnan(X)) = Zbar;    
end
