

sim = squeeze(stock(280,:,:))

hist = dDebt_Eobs;

histc = repmat(hist,[1 167])
proy = [ histc; sim];

p_inf = 5:5:50;
p_sup = 95:-5:50;

perc_inf = prctile(proy,p_inf,2);
perc_sup = prctile(proy,p_sup,2);

% Colores
for i = 2:9
colores_rgb(i,:) = [255 204-(i-1)*20 204-(i-1)*20];
colores(i,:) = colores_rgb(i,:)./255;
end
colores(10,:) = [206	22	32]/255;

dat = 2002:0.25:2018.75;

media = mean(proy,2);

for i = 2:9
hold on
shadedplot(dat,perc_inf(:,i)',perc_sup(:,i)',colores(i,:),colores(i,:)); %% sobreponiendo
end
hold on
plot(dat,media,'color',colores(10,:))
axis tight
