
function [y,C,D]  = MissData(y,C,D)
%______________________________________________________________________
% PROC missdata                                                        
% PURPOSE: eliminates the rows in y & matrices C, D that correspond to     
%          missing data (NaN) in y                                                                                  
%______________________________________________________________________
  ix = ~isnan(y);

  y  =  y(ix);
  C  =  C(ix,:);  
  D  =  D;%D(ix,ix);
end


